import tkinter as tk
import tkinter.ttk as ttk
import random

def clicks():
    global count_0, count_1, count_2, count_3

    count_0 += 1
    count_1 += 1
    count_2 += 1
    count_3 += 1


def num_1():
    global count_1, update_1

    if count_1 < 1:
        result_1.set(random.randint(0, 9))
    elif update_1 == 1050:
        result_1.set(random.randint(0, 9))
        update_1 = 10000000000
    elif update_1 < 1051:
        update_1 += 40
        result_1.set(random.randint(0, 9))

    root.after(update_1, num_1)


def num_2():
    global count_2, update_2

    if count_2 < 2:
        result_2.set(random.randint(0, 9))
    elif update_2 == 1050:
        result_2.set(random.randint(0, 9))
        update_2 = 10000000000
    elif update_2 < 1051:
        update_2 += 40
        result_2.set(random.randint(0, 9))

    root.after(update_2, num_2)


def num_3():
    global count_3, update_3

    if count_3 < 3:
        result_3.set(random.randint(0, 9))
    elif update_3 == 1050:
        result_3.set(random.randint(0, 9))
        update_3 = 10000000000
    elif update_3 < 1051:
        update_3 += 40
        result_3.set(random.randint(0, 9))

    root.after(update_3, num_3)

def num_all():
    global update_0, update_1, update_2, update_3

    if update_0 == 1050:
        update_0 = 10000000000
    elif update_0 < 1051:
        update_0 += 40

    update_1 = update_2 = update_3 = update_0

    root.after(update_0, num_all)


def reset():
    global count_0, count_1, count_2, count_3, update_0, update_1, update_2, update_3

    count_0 = count_1 = count_2 = count_3 = 0
    update_0 = update_1 = update_2 = update_3 = 10
    num_1()
    num_2()
    num_3()


count_0 = count_1 = count_2 = count_3 = 0
update_0 = update_1 = update_2 = update_3 = 10

root = tk.Tk()
root.geometry('360x180')
root.resizable(False, False)
root.configure(background='seashell')

result_1 = tk.StringVar()
result_2 = tk.StringVar()
result_3 = tk.StringVar()

feedback_1 = tk.Entry(root, font='arial 72 bold', textvariable=result_1, state='disabled', disabledbackground='grey80',
                    disabledforeground="black", width=5, justify='center')
feedback_1.place(x=10, y=10, width=100, height=100)
feedback_2 = tk.Entry(root, font='arial 72 bold', textvariable=result_2, state='disabled', disabledbackground='grey80',
                    disabledforeground="black", width=5, justify='center')
feedback_2.place(x=130, y=10, width=100, height=100)
feedback_3 = tk.Entry(root, font='arial 72 bold', textvariable=result_3, state='disabled', disabledbackground='grey80',
                    disabledforeground="black", width=5, justify='center')
feedback_3.place(x=250, y=10, width=100, height=100)

pick_one = ttk.Button(root, text='PICK ONE', state='normal', style="Custom.TButton", command=lambda:[num_1(),num_2(),num_3(),clicks()])
pick_one.place(x=50, y=150)
pick_all = ttk.Button(root, text='PICK All', state='normal', style="Custom.TButton", command=num_all)
pick_all.place(x=140, y=150)
reset = ttk.Button(root, text='RESET', state='normal', style="Custom.TButton", command=reset)
reset.place(x=230, y=150)

num_1()
num_2()
num_3()


root.mainloop()