import random, os, time, sys


def yes_no(risk):
    stop = 0
    yes = 0
    while stop < 10:
        decider = random.random()
        if decider >= 0.5:
            yes += 1
        stop += 1

    if yes >= risk:
        return 'Yes'

    return 'No'


def computer(comp_current_total, comp_current_selected, cards, comp_aceed):
    while True:
        comp_card = random.choice(list(cards.items()))

        if comp_card in comp_current_selected:
            continue

        if comp_aceed and comp_card[0] in ('Ace.H', 'Ace.S', 'Ace.D', 'Ace.C'):
            comp_total = comp_card[1] + comp_current_total - 10
        else:
            comp_total = comp_card[1] + comp_current_total

        if comp_card[0] in ('Ace.H', 'Ace.S', 'Ace.D', 'Ace.C'):
            comp_aceed = True

        comp_current_selected.append(comp_card)

        return comp_current_selected, comp_total, comp_aceed


def you(you_current_total, you_current_selected, cards, you_aceed):
    while True:
        you_card = random.choice(list(cards.items()))

        if you_card in you_current_selected:
            continue

        if you_aceed and you_card[0] in ('Ace.H', 'Ace.S', 'Ace.D', 'Ace.C'):
            you_total = you_card[1] + you_current_total - 10
        else:
            you_total = you_card[1] + you_current_total

        if you_card[0] in ('Ace.H', 'Ace.S', 'Ace.D', 'Ace.C'):
            you_aceed = True

        you_current_selected.append(you_card)

        return you_current_selected, you_total, you_aceed


cards = {'1.H': 1, '1.S': 1, '1.C': 1, '1.D': 1, '2.H': 2, '2.S': 2, '2.C': 2, '2.D': 2, '3.H': 3, '3.S': 3, '3.C': 3,
         '3.D': 3, '4.H': 4, '4.S': 4, '4.C': 4, '4.D': 4, '5.H': 5, '5.S': 5, '5.C': 5, '5.D': 5, '6.H': 6, '6.S': 6,
         '6.C': 6, '6.D': 6, '7.H': 7, '7.S': 7, '7.C': 7, '7.D': 7, '8.H': 8, '8.S': 8, '8.C': 8, '8.D': 8, '9.H': 9,
         '9.S': 9, '9.C': 9, '9.D': 9, '10.H': 10, '10.S': 10, '10.C': 10, '10.D': 10, 'Jack.H': 10, 'Jack.S': 10,
         'Jack.C': 10, 'Jack.D': 10, 'Queen.H': 10, 'Queen.S': 10, 'Queen.C': 10, 'Queen.D': 10, 'King.H': 10,
         'King.S': 10, 'King.C': 10, 'King.D': 10, 'Ace.H': 11, 'Ace.S': 11, 'Ace.C': 11, 'Ace.D': 11
         }

os.system('cls')
you_wins = 0
comp_wins = 0
play = True
input('To start the game, press enter')

while play != False:
    os.system('cls')

    comp_current_selected = []
    comp_current_total = 0
    comp_aceed = False
    comp_decision = 'Yes'
    comp_ace_is_1 = False

    while comp_current_total < 21 and comp_decision == 'Yes':
        c_selected, c_total, c_ace = computer(comp_current_total, comp_current_selected, cards, comp_aceed)
        comp_current_selected = c_selected
        comp_current_total = c_total
        comp_aceed = c_ace
        if comp_current_total < 12:
            continue
        elif comp_current_total == 12:
            comp_decision = yes_no(2)
        elif comp_current_total == 13:
            comp_decision = yes_no(3)
        elif comp_current_total == 14:
            comp_decision = yes_no(4)
        elif comp_current_total == 15:
            comp_decision = yes_no(5)
        elif comp_current_total == 16:
            comp_decision = yes_no(6)
        elif comp_current_total == 17:
            comp_decision = yes_no(7)
        elif comp_current_total == 18:
            comp_decision = yes_no(8)
        elif comp_current_total == 19:
            comp_decision = yes_no(9)
        elif comp_current_total == 20:
            comp_decision = yes_no(10)
        elif comp_current_total == 21:
            break
        elif comp_current_total > 21 and comp_aceed and not comp_ace_is_1:
            comp_current_total -= 10
            comp_ace_is_1 = True

    print('The computer\'s hand is dealt. Your hand will now be dealt.')
    time.sleep(2)
    os.system('cls')

    you_current_selected = []
    you_current_total = 0
    you_aceed = False
    you_ace_is_1 = False

    while you_current_total < 21:
        y_selected, y_total, y_ace = you(you_current_total, you_current_selected, cards, you_aceed)
        you_current_selected = y_selected
        you_current_total = y_total
        you_aceed = y_ace

        if len(you_current_selected) < 2:
            continue

        if you_current_total > 21 and you_aceed and not you_ace_is_1:
            you_current_total -= 10
            you_ace_is_1 = True

        if you_current_total > 21 and you_ace_is_1:
            break

        if you_current_total > 21:
            break

        print(f'\nYour current hand is \033[45m{you_current_selected}\033[0m which totals {you_current_total}.\n')
        draw_again = input('Cards have been dealt. Do you want to draw another card (b to break): ')

        os.system('cls')

        if draw_again == 'b':
            break
        else:
            continue

    print('Your Hand = ', end='')
    for card_you in you_current_selected:
        if 'D' in card_you[0] or 'H' in card_you[0]:
            print(f'\x1b[31;47m{card_you}\x1b[0m ', end='')
        else:
            print(f'\x1b[30;47m{card_you}\x1b[0m ', end='')

    print('')
    print('\nComputer\'s Hand = ', end='')
    for card_comp in comp_current_selected:
        if 'D' in card_comp[0] or 'H' in card_comp[0]:
            print(f'\x1b[31;47m{card_comp}\x1b[0m ', end='')
        else:
            print(f'\x1b[30;47m{card_comp}\x1b[0m ', end='')

    print('')
    print('')

    if comp_current_total > 21 and you_current_total > 21:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. There is no winner\n')
    elif comp_current_total == you_current_total:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. There is no winner\n')
    elif comp_current_total > 21 and you_current_total <= 21:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. You are the winner\n')
        you_wins += 1
    elif comp_current_total <= 21 and you_current_total > 21:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. Computer wins\n')
        comp_wins += 1
    elif comp_current_total <= 21 and comp_current_total > you_current_total:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. Computer wins\n')
        comp_wins += 1
    elif you_current_total <= 21 and comp_current_total < you_current_total:
        print(f'\nThe computer is on {comp_current_total} and you are on {you_current_total}. You are the winner\n')
        you_wins += 1

    print(
        f'''
        The current scorecard is:
        You: {you_wins}
        Computer: {comp_wins}
        '''
    )

    play = input('\nDo you want to play again (e to exit): ')

    if play == 'e':
        play = False
        os.system('cls')
        
one = ''
if you_wins > 1 or comp_wins > 1:
    one = 's'
if you_wins > comp_wins:
    print(f'You have won {you_wins} game{one} compared to the computer\'s {comp_wins}.\n')
    print('\x1b[44mYou are the winner.\x1b[0m')
elif you_wins < comp_wins:
    print(f'The computer has won {comp_wins} game{one} compared to your {you_wins}.\n')
    print('\x1b[44mThe computer wins.\x1b[0m')
elif you_wins == comp_wins:
    print(f'You have {you_wins} wins and the computer has {comp_wins} wins.\n')
    print('\x1b[44mThe result is a draw.\x1b[0m')

print('\n\n-------------------------------------------------')
print('\n             The game has ended')
time.sleep(8)
sys.exit()
